package sun.rmi.transport.proxy;

import java.io.IOException;
import java.io.OutputStream;
import java.io.FilterOutputStream;

class HttpSendOutputStream extends FilterOutputStream
{
    HttpSendSocket owner;
    
    public HttpSendOutputStream(OutputStream out, HttpSendSocket owner) throws IOException {
        super(out);
        this.owner = owner;
    }
    
    public void deactivate() {
        this.out = null;
    }
    
    @Override
    public void write(int n) throws IOException {
        if (this.out == null) {
            this.out = this.owner.writeNotify();
        }
        this.out.write(n);
    }
    
    @Override
    public void write(byte[] b, int off, int len) throws IOException {
        if (len == 0) {
            return;
        }
        if (this.out == null) {
            this.out = this.owner.writeNotify();
        }
        this.out.write(b, off, len);
        return;
    }
    
    @Override
    public void flush() throws IOException {
        if (this.out != null) {
            this.out.flush();
        }
    }
    
    @Override
    public void close() throws IOException {
        this.flush();
        this.owner.close();
    }
}
